/*
 * This file is generated by jOOQ.
*/
package com.tabajara.base.tables;


import com.tabajara.base.Indexes;
import com.tabajara.base.Keys;
import com.tabajara.base.Public;
import com.tabajara.base.tables.records.ArduinosensorRecord;

import java.util.Arrays;
import java.util.List;

import javax.annotation.Generated;

import org.jooq.Field;
import org.jooq.ForeignKey;
import org.jooq.Identity;
import org.jooq.Index;
import org.jooq.Name;
import org.jooq.Schema;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.UniqueKey;
import org.jooq.impl.DSL;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@Generated(
    value = {
        "http://www.jooq.org",
        "jOOQ version:3.10.5"
    },
    comments = "This class is generated by jOOQ"
)
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class Arduinosensor extends TableImpl<ArduinosensorRecord> {

    private static final long serialVersionUID = -702293685;

    /**
     * The reference instance of <code>public.arduinosensor</code>
     */
    public static final Arduinosensor ARDUINOSENSOR = new Arduinosensor();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<ArduinosensorRecord> getRecordType() {
        return ArduinosensorRecord.class;
    }

    /**
     * The column <code>public.arduinosensor.ardsenid</code>.
     */
    public final TableField<ArduinosensorRecord, Integer> ARDSENID = createField("ardsenid", org.jooq.impl.SQLDataType.INTEGER.nullable(false).defaultValue(org.jooq.impl.DSL.field("nextval('arduinosensor_ardsenid_seq'::regclass)", org.jooq.impl.SQLDataType.INTEGER)), this, "");

    /**
     * The column <code>public.arduinosensor.fkardid</code>.
     */
    public final TableField<ArduinosensorRecord, Integer> FKARDID = createField("fkardid", org.jooq.impl.SQLDataType.INTEGER, this, "");

    /**
     * The column <code>public.arduinosensor.fksenid</code>.
     */
    public final TableField<ArduinosensorRecord, Integer> FKSENID = createField("fksenid", org.jooq.impl.SQLDataType.INTEGER, this, "");

    /**
     * Create a <code>public.arduinosensor</code> table reference
     */
    public Arduinosensor() {
        this(DSL.name("arduinosensor"), null);
    }

    /**
     * Create an aliased <code>public.arduinosensor</code> table reference
     */
    public Arduinosensor(String alias) {
        this(DSL.name(alias), ARDUINOSENSOR);
    }

    /**
     * Create an aliased <code>public.arduinosensor</code> table reference
     */
    public Arduinosensor(Name alias) {
        this(alias, ARDUINOSENSOR);
    }

    private Arduinosensor(Name alias, Table<ArduinosensorRecord> aliased) {
        this(alias, aliased, null);
    }

    private Arduinosensor(Name alias, Table<ArduinosensorRecord> aliased, Field<?>[] parameters) {
        super(alias, null, aliased, parameters, "");
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Schema getSchema() {
        return Public.PUBLIC;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public List<Index> getIndexes() {
        return Arrays.<Index>asList(Indexes.ARDUINOSENSOR_PKEY);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Identity<ArduinosensorRecord, Integer> getIdentity() {
        return Keys.IDENTITY_ARDUINOSENSOR;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public UniqueKey<ArduinosensorRecord> getPrimaryKey() {
        return Keys.ARDUINOSENSOR_PKEY;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public List<UniqueKey<ArduinosensorRecord>> getKeys() {
        return Arrays.<UniqueKey<ArduinosensorRecord>>asList(Keys.ARDUINOSENSOR_PKEY);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public List<ForeignKey<ArduinosensorRecord, ?>> getReferences() {
        return Arrays.<ForeignKey<ArduinosensorRecord, ?>>asList(Keys.ARDUINOSENSOR__ARDUINOSENSOR_FKARDID_FKEY, Keys.ARDUINOSENSOR__ARDUINOSENSOR_FKSENID_FKEY);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Arduinosensor as(String alias) {
        return new Arduinosensor(DSL.name(alias), this);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Arduinosensor as(Name alias) {
        return new Arduinosensor(alias, this);
    }

    /**
     * Rename this table
     */
    @Override
    public Arduinosensor rename(String name) {
        return new Arduinosensor(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public Arduinosensor rename(Name name) {
        return new Arduinosensor(name, null);
    }
}
